#include "knl_sos.h"
#include "err.h"
#include "cci_use.h"
sos_Object make_sos_Int_object(sos_Int x)
{  return sos_object_from_extern (&x,bcopy_from_sos_Int,_sos_Int_type); }
sos_Int make_sos_Int(sos_Object o)
{  sos_Int x;
   sos_extern_from_object (&x,o,bcopy_to_sos_Int,_sos_Int_type);
   return x; }
sos_Object make_sos_Char_object(sos_Char x)
{  return sos_object_from_extern (&x,bcopy_from_sos_Char,_sos_Char_type); }
sos_Char make_sos_Char(sos_Object o)
{  sos_Char x;
   sos_extern_from_object (&x,o,bcopy_to_sos_Char,_sos_Char_type);
   return x; }
sos_Object make_sos_Cstring_object(sos_Cstring x)
{  return sos_object_from_extern (&x,bcopy_from_sos_Cstring,_sos_Cstring_type); }
sos_Cstring make_sos_Cstring(sos_Object o)
{  sos_Cstring x;
   sos_extern_from_object (&x,o,bcopy_to_sos_Cstring,_sos_Cstring_type);
   return x; }
sos_Object make_sos_Pointer_object(sos_Pointer x)
{  return sos_object_from_extern (&x,bcopy_from_sos_Pointer,_sos_Pointer_type); }
sos_Pointer make_sos_Pointer(sos_Object o)
{  sos_Pointer x;
   sos_extern_from_object (&x,o,bcopy_to_sos_Pointer,_sos_Pointer_type);
   return x; }
sos_Object make_sos_Container_object(sos_Container x)
{  return sos_object_from_extern (&x,bcopy_from_sos_Container,_sos_Container_type); }
sos_Container make_sos_Container(sos_Object o)
{  sos_Container x;
   sos_extern_from_object (&x,o,bcopy_to_sos_Container,_sos_Container_type);
   return x; }
sos_Object make_sos_Id_object(sos_Id x)
{  return sos_object_from_extern (&x,bcopy_from_sos_Id,_sos_Id_type); }
sos_Id make_sos_Id(sos_Object o)
{  sos_Id x;
   sos_extern_from_object (&x,o,bcopy_to_sos_Id,_sos_Id_type);
   return x; }
sos_Object make_sos_Offset_object(sos_Offset x)
{  return sos_object_from_extern (&x,bcopy_from_sos_Offset,_sos_Offset_type); }
sos_Offset make_sos_Offset(sos_Object o)
{  sos_Offset x;
   sos_extern_from_object (&x,o,bcopy_to_sos_Offset,_sos_Offset_type);
   return x; }
sos_Object make_sos_Bool_object(sos_Bool x)
{  return sos_object_from_extern (&x,bcopy_from_sos_Bool,_sos_Bool_type); }
sos_Bool make_sos_Bool(sos_Object o)
{  sos_Bool x;
   sos_extern_from_object (&x,o,bcopy_to_sos_Bool,_sos_Bool_type);
   return x; }
sos_Object make_sos_Eq_kind_object(sos_Eq_kind x)
{  return sos_object_from_extern (&x,bcopy_from_sos_Eq_kind,_sos_Eq_kind_type); }
sos_Eq_kind make_sos_Eq_kind(sos_Object o)
{  sos_Eq_kind x;
   sos_extern_from_object (&x,o,bcopy_to_sos_Eq_kind,_sos_Eq_kind_type);
   return x; }
sos_Object make_sos_Comp_result_object(sos_Comp_result x)
{  return sos_object_from_extern (&x,bcopy_from_sos_Comp_result,_sos_Comp_result_type); }
sos_Comp_result make_sos_Comp_result(sos_Object o)
{  sos_Comp_result x;
   sos_extern_from_object (&x,o,bcopy_to_sos_Comp_result,_sos_Comp_result_type);
   return x; }
_sos_Object* _sos_Object::_make(sos_Typed_id &tpid)
{  return (_sos_Object*)cci_Schema_impl::get_make_obj(_sos_Object_type,tpid.get_tp());
}
sos_Offset _sos_Object::_size(){return 8;}
void _sos_Object::_create(sos_Typed_id&_tpid){
   sos_Object _x=sos_Object::make(_tpid,this);
}
void _sos_Object::_copy(sos_Typed_id&_tpid,sos_Object y){
   sos_Object x=sos_Object::make(_tpid,this);
}
sos_Object _sos_Object::_clone(sos_Typed_id&_tpid,sos_Container cnt){
   sos_Object _x=sos_Object::make(_tpid,this);
   return sos_Object::copy(_x,cnt);}
void _sos_Object::destroy(sos_Typed_id&_tpid){
   _tpid.container().deallocate(_tpid.offset(),8);}
void _sos_Object::assign(sos_Typed_id&_tpid,sos_Object o){
   sos_Object x=sos_Object::make(_tpid,this);
   _sos_Object::local_assign(x,o);
}
sos_Bool _sos_Object::equal(sos_Typed_id&_tpid,sos_Object o,sos_Eq_kind eq_kind){
   sos_Object x=sos_Object::make(_tpid,this);
   if (! _sos_Object::local_equal(x,o,eq_kind)) return FALSE;
   return TRUE;}
sos_Int _sos_Object::hash_value(sos_Typed_id&_tpid){
   sos_Object x=sos_Object::make(_tpid,this);
   sos_Int result=0;
   result ^= _sos_Object::local_hash_value(x);
   return result;}
sos_Id _sos_Object::get_type_id(sos_Typed_id&_tpid)
{  union {sos_Id x; char c[8];} u; sos_Id a;
   _tpid.container().read(_tpid.offset()+_offset_sos_Object()+0,8,&u);
   bcopy_to_sos_Id(&a,&u);
   return a;}
void _sos_Object::set_type_id(sos_Typed_id&_tpid,sos_Id a){
   union {sos_Id x; char c[8];} u;
   bcopy_from_sos_Id(&a,&u);
   _tpid.container().write(_tpid.offset() + _offset_sos_Object() + 0,8,&u);
}
static sos_Object _univ_15319856_55288(sos_Object o,sos_Object_Array){
   sos_Object::make (o).destroy();
   return NO_OBJECT;}
static sos_Object _univ_15319856_50448(sos_Object o,sos_Object_Array p){
   sos_Object o1=p[0];
   sos_Object::make (o).assign(sos_Object::make(o1));
   return NO_OBJECT;}
static sos_Object _univ_15319856_55804(sos_Object o,sos_Object_Array p){
   sos_Object o1=p[0], o2=p[1];
   return ::make_sos_Bool_object(sos_Object::make (o).equal(sos_Object::make(o1),::make_sos_Eq_kind(o2)));}
static sos_Object _univ_15319856_55868(sos_Object o,sos_Object_Array){
   return ::make_sos_Int_object(sos_Object::make (o).hash_value());}
static sos_Object _univ_15319856_55932(sos_Object o,sos_Object_Array){
   return sos_Object::make(sos_Object::make (o).type());}
static sos_Object _univ_15319856_55996(sos_Object o,sos_Object_Array p){
   sos_Object o1=p[0];
   return ::make_sos_Bool_object(sos_Object::make (o).has_type(sos_Type::make(o1)));}
static sos_Object _univ_15319856_56060(sos_Object o,sos_Object_Array p){
   sos_Object o1=p[0];
   return ::make_sos_Bool_object(sos_Object::make (o).isa(sos_Type::make(o1)));}
static sos_Object _univ_15319856_56124(sos_Object o,sos_Object_Array p){
   sos_Object o1=p[0];
   return ::make_sos_Bool_object(sos_Object::make (o).is_some(sos_Type::make(o1)));}
static sos_Object _univ_15319856_56188(sos_Object o,sos_Object_Array){
   return ::make_sos_Bool_object(sos_Object::make (o).is_value());}
static sos_Object _univ_15319856_56252(sos_Object o,sos_Object_Array){
   return ::make_sos_Int_object(sos_Object::make (o).size());}
static sos_Object _univ_15319856_56320(sos_Object o,sos_Object_Array p){
   sos_Object o1=p[0];
   return ::make_sos_Bool_object(sos_Object::make (o).identical(sos_Object::make(o1)));}
static sos_Object _univ_15319856_56384(sos_Object o,sos_Object_Array p){
   sos_Object o1=p[0];
   return ::make_sos_Bool_object(sos_Object::make (o).operator==(sos_Object::make(o1)));}
static sos_Object _univ_15319856_56448(sos_Object o,sos_Object_Array p){
   sos_Object o1=p[0];
   return ::make_sos_Bool_object(sos_Object::make (o).operator!=(sos_Object::make(o1)));}
static sos_Object _univ_15319856_56512(sos_Object o,sos_Object_Array p){
   sos_Object o1=p[0];
   return ::make_sos_Bool_object(sos_Object::make (o).like(sos_Object::make(o1)));}
static sos_Object _univ_15319856_56576(sos_Object o,sos_Object_Array p){
   sos_Object o1=p[0];
   return ::make_sos_Comp_result_object(sos_Object::make (o).compare_ids(sos_Object::make(o1)));}
static void _init_meth_15319856_3764(){
   cci_Schema_impl::enter_fun(sos_Id::make(sos_Container::make(15319856),55288),(cci_Fun)_univ_15319856_55288);
   cci_Schema_impl::enter_fun(sos_Id::make(sos_Container::make(15319856),50448),(cci_Fun)_univ_15319856_50448);
   cci_Schema_impl::enter_fun(sos_Id::make(sos_Container::make(15319856),55804),(cci_Fun)_univ_15319856_55804);
   cci_Schema_impl::enter_fun(sos_Id::make(sos_Container::make(15319856),55868),(cci_Fun)_univ_15319856_55868);
   cci_Schema_impl::enter_fun(sos_Id::make(sos_Container::make(15319856),55932),(cci_Fun)_univ_15319856_55932);
   cci_Schema_impl::enter_fun(sos_Id::make(sos_Container::make(15319856),55996),(cci_Fun)_univ_15319856_55996);
   cci_Schema_impl::enter_fun(sos_Id::make(sos_Container::make(15319856),56060),(cci_Fun)_univ_15319856_56060);
   cci_Schema_impl::enter_fun(sos_Id::make(sos_Container::make(15319856),56124),(cci_Fun)_univ_15319856_56124);
   cci_Schema_impl::enter_fun(sos_Id::make(sos_Container::make(15319856),56188),(cci_Fun)_univ_15319856_56188);
   cci_Schema_impl::enter_fun(sos_Id::make(sos_Container::make(15319856),56252),(cci_Fun)_univ_15319856_56252);
   cci_Schema_impl::enter_fun(sos_Id::make(sos_Container::make(15319856),56320),(cci_Fun)_univ_15319856_56320);
   cci_Schema_impl::enter_fun(sos_Id::make(sos_Container::make(15319856),56384),(cci_Fun)_univ_15319856_56384);
   cci_Schema_impl::enter_fun(sos_Id::make(sos_Container::make(15319856),56448),(cci_Fun)_univ_15319856_56448);
   cci_Schema_impl::enter_fun(sos_Id::make(sos_Container::make(15319856),56512),(cci_Fun)_univ_15319856_56512);
   cci_Schema_impl::enter_fun(sos_Id::make(sos_Container::make(15319856),56576),(cci_Fun)_univ_15319856_56576);
}
static void _init_comp_15319856_3764(){
}
static sos_Object _univ_15319856_56768(sos_Object,sos_Object_Array p){
   sos_Object o1=p[0];
   return sos_Object::make(sos_Object::create(::make_sos_Container(o1)));}
static sos_Object _univ_15319856_56832(sos_Object,sos_Object_Array p){
   sos_Object o1=p[0], o2=p[1];
   return sos_Object::make(sos_Object::copy(sos_Object::make(o1),::make_sos_Container(o2)));}
static sos_Object _univ_15319856_56896(sos_Object,sos_Object_Array p){
   sos_Object o1=p[0], o2=p[1];
   return sos_Object::make(sos_Object::clone(sos_Object::make(o1),::make_sos_Container(o2)));}
static void _init_stat_15319856_3764(){
   cci_Schema_impl::enter_fun(sos_Id::make(sos_Container::make(15319856),56768),(cci_Fun)_univ_15319856_56768);
   cci_Schema_impl::enter_fun(sos_Id::make(sos_Container::make(15319856),56832),(cci_Fun)_univ_15319856_56832);
   cci_Schema_impl::enter_fun(sos_Id::make(sos_Container::make(15319856),56896),(cci_Fun)_univ_15319856_56896);
}
_sos_Object *__sos_Object_obj;
static void _init_new_15319856_3764(){
   cci_Schema_impl::enter_make_obj(_sos_Object_type,_sos_Object_type,(_sos_Object*)__sos_Object_obj);
}
sos_Object sos_Object::make(sos_Typed_id&p){
   sos_Object o; o._tpid=p;
   o._ref=_sos_Object::_make(p); return o;}
sos_Object sos_Object::make(sos_Root_class& o){return sos_Object::make(o.typed_id());}
   sos_Offset sos_Object::_size(){return _ref->_size();}
sos_Object sos_Object::create(sos_Container _cnt){
   sos_Object _x=sos_Object::make(sos_Typed_id::allocate(sos_Object_type,_cnt,8));
   _x._ref->_create(_x._tpid);
   return _x;
}
sos_Object sos_Object::copy(sos_Object y,sos_Container cnt){
   sos_Object x=sos_Object::make(sos_Typed_id::allocate(sos_Object_type,cnt,8));
   x._ref->_copy(x._tpid,y);
   x.assign(y);
   return x;
}
sos_Object sos_Object::clone(sos_Object o,sos_Container cnt){
   return sos_Object::make (o._ref->_clone(o._tpid,cnt));
}
void sos_Object::destroy(){(_ref->destroy(_tpid));}
void sos_Object::assign(sos_Object source){(_ref->assign(_tpid,source));}
sos_Bool sos_Object::equal(sos_Object o,sos_Eq_kind eq_kind){return (_ref->equal(_tpid,o,eq_kind));}
sos_Int sos_Object::hash_value(){return (_ref->hash_value(_tpid));}
sos_Type sos_Object::type(){return (_ref->type(_tpid));}
sos_Bool sos_Object::has_type(sos_Type _p1){return (_ref->has_type(_tpid,_p1));}
sos_Bool sos_Object::isa(sos_Type _p1){return (_ref->isa(_tpid,_p1));}
sos_Bool sos_Object::is_some(sos_Type _p1){return (_ref->is_some(_tpid,_p1));}
sos_Bool sos_Object::is_value(){return (_ref->is_value(_tpid));}
sos_Int sos_Object::size(){return (_ref->size(_tpid));}
sos_Bool sos_Object::identical(sos_Object _p1){return (_ref->identical(_tpid,_p1));}
sos_Bool sos_Object::operator==(sos_Object _p1){return (_ref->__equal(_tpid,_p1));}
sos_Bool sos_Object::operator!=(sos_Object _p1){return (_ref->__not_equal(_tpid,_p1));}
sos_Bool sos_Object::like(sos_Object _p1){return (_ref->like(_tpid,_p1));}
sos_Comp_result sos_Object::compare_ids(sos_Object _p1){return (_ref->compare_ids(_tpid,_p1));}
sos_Id sos_Object::get_type_id(){return (_ref->get_type_id(_tpid));}
void sos_Object::set_type_id(sos_Id _p1){(_ref->set_type_id(_tpid,_p1));}
void sos_Object::local_assign(sos_Object _p1,sos_Object _p2){(_sos_Object::local_assign(_p1,_p2));}
sos_Bool sos_Object::local_equal(sos_Object _p1,sos_Object _p2,sos_Eq_kind _p3){return (_sos_Object::local_equal(_p1,_p2,_p3));}
sos_Int sos_Object::local_hash_value(sos_Object _p1){return (_sos_Object::local_hash_value(_p1));}
_sos_Ordered_object* _sos_Ordered_object::_make(sos_Typed_id &tpid)
{  return (_sos_Ordered_object*)cci_Schema_impl::get_make_obj(_sos_Ordered_object_type,tpid.get_tp());
}
sos_Offset _sos_Ordered_object::_size(){return 8;}
void _sos_Ordered_object::_create(sos_Typed_id&_tpid){
   sos_Ordered_object _x=sos_Ordered_object::make(_tpid,this);
}
void _sos_Ordered_object::_copy(sos_Typed_id&_tpid,sos_Ordered_object y){
   sos_Ordered_object x=sos_Ordered_object::make(_tpid,this);
}
sos_Object _sos_Ordered_object::_clone(sos_Typed_id&_tpid,sos_Container cnt){
   sos_Ordered_object _x=sos_Ordered_object::make(_tpid,this);
   return sos_Ordered_object::copy(_x,cnt);}
void _sos_Ordered_object::destroy(sos_Typed_id&_tpid){
   _tpid.container().deallocate(_tpid.offset(),8);}
void _sos_Ordered_object::assign(sos_Typed_id&_tpid,sos_Object o){
   sos_Ordered_object x=sos_Ordered_object::make(_tpid,this);
   _sos_Object::local_assign(x,o);
   _sos_Ordered_object::local_assign(x,o);
}
void _sos_Ordered_object::local_assign(sos_Ordered_object x,sos_Object o){
}
sos_Bool _sos_Ordered_object::equal(sos_Typed_id&_tpid,sos_Object o,sos_Eq_kind eq_kind){
   sos_Ordered_object x=sos_Ordered_object::make(_tpid,this);
   if (! _sos_Object::local_equal(x,o,eq_kind)) return FALSE;
   if (! _sos_Ordered_object::local_equal(x,o,eq_kind)) return FALSE;
   return TRUE;}
sos_Bool _sos_Ordered_object::local_equal(sos_Ordered_object,sos_Object,sos_Eq_kind) { return TRUE;}
sos_Int _sos_Ordered_object::hash_value(sos_Typed_id&_tpid){
   sos_Ordered_object x=sos_Ordered_object::make(_tpid,this);
   sos_Int result=0;
   result ^= _sos_Object::local_hash_value(x);
   result ^= _sos_Ordered_object::local_hash_value(x);
   return result;}
sos_Int _sos_Ordered_object::local_hash_value(sos_Ordered_object x){
   return x.container().hash_value(x.offset()+x._ref->_offset_sos_Ordered_object(),0);}
sos_Comp_result _sos_Ordered_object::compare(sos_Typed_id&,sos_Ordered_object ) {
   err_raise_abstract_method ("sos_Ordered_object::compare"); 
   return (sos_Comp_result) 0; }
static sos_Object _univ_15319856_57152(sos_Object o,sos_Object_Array){
   sos_Ordered_object::make (o).destroy();
   return NO_OBJECT;}
static sos_Object _univ_15319856_57216(sos_Object o,sos_Object_Array p){
   sos_Object o1=p[0];
   sos_Ordered_object::make (o).assign(sos_Object::make(o1));
   return NO_OBJECT;}
static sos_Object _univ_15319856_57280(sos_Object o,sos_Object_Array p){
   sos_Object o1=p[0], o2=p[1];
   return ::make_sos_Bool_object(sos_Ordered_object::make (o).equal(sos_Object::make(o1),::make_sos_Eq_kind(o2)));}
static sos_Object _univ_15319856_57344(sos_Object o,sos_Object_Array){
   return ::make_sos_Int_object(sos_Ordered_object::make (o).hash_value());}
static sos_Object _univ_15319856_57408(sos_Object o,sos_Object_Array p){
   sos_Object o1=p[0];
   return ::make_sos_Comp_result_object(sos_Ordered_object::make (o).compare(sos_Ordered_object::make(o1)));}
static sos_Object _univ_15319856_57472(sos_Object o,sos_Object_Array p){
   sos_Object o1=p[0];
   return ::make_sos_Bool_object(sos_Ordered_object::make (o).operator<(sos_Ordered_object::make(o1)));}
static sos_Object _univ_15319856_57536(sos_Object o,sos_Object_Array p){
   sos_Object o1=p[0];
   return ::make_sos_Bool_object(sos_Ordered_object::make (o).operator<=(sos_Ordered_object::make(o1)));}
static sos_Object _univ_15319856_57600(sos_Object o,sos_Object_Array p){
   sos_Object o1=p[0];
   return ::make_sos_Bool_object(sos_Ordered_object::make (o).operator>(sos_Ordered_object::make(o1)));}
static sos_Object _univ_15319856_57664(sos_Object o,sos_Object_Array p){
   sos_Object o1=p[0];
   return ::make_sos_Bool_object(sos_Ordered_object::make (o).operator>=(sos_Ordered_object::make(o1)));}
static void _init_meth_15319856_13556(){
   cci_Schema_impl::enter_fun(sos_Id::make(sos_Container::make(15319856),57152),(cci_Fun)_univ_15319856_57152);
   cci_Schema_impl::enter_fun(sos_Id::make(sos_Container::make(15319856),57216),(cci_Fun)_univ_15319856_57216);
   cci_Schema_impl::enter_fun(sos_Id::make(sos_Container::make(15319856),57280),(cci_Fun)_univ_15319856_57280);
   cci_Schema_impl::enter_fun(sos_Id::make(sos_Container::make(15319856),57344),(cci_Fun)_univ_15319856_57344);
   cci_Schema_impl::enter_fun(sos_Id::make(sos_Container::make(15319856),57408),(cci_Fun)_univ_15319856_57408);
   cci_Schema_impl::enter_fun(sos_Id::make(sos_Container::make(15319856),57472),(cci_Fun)_univ_15319856_57472);
   cci_Schema_impl::enter_fun(sos_Id::make(sos_Container::make(15319856),57536),(cci_Fun)_univ_15319856_57536);
   cci_Schema_impl::enter_fun(sos_Id::make(sos_Container::make(15319856),57600),(cci_Fun)_univ_15319856_57600);
   cci_Schema_impl::enter_fun(sos_Id::make(sos_Container::make(15319856),57664),(cci_Fun)_univ_15319856_57664);
}
static void _init_comp_15319856_13556(){
}
static sos_Object _univ_15319856_57728(sos_Object,sos_Object_Array p){
   sos_Object o1=p[0];
   return sos_Object::make(sos_Ordered_object::create(::make_sos_Container(o1)));}
static sos_Object _univ_15319856_57792(sos_Object,sos_Object_Array p){
   sos_Object o1=p[0], o2=p[1];
   return sos_Object::make(sos_Ordered_object::copy(sos_Ordered_object::make(o1),::make_sos_Container(o2)));}
static sos_Object _univ_15319856_57856(sos_Object,sos_Object_Array p){
   sos_Object o1=p[0], o2=p[1];
   return sos_Object::make(sos_Ordered_object::clone(sos_Ordered_object::make(o1),::make_sos_Container(o2)));}
static void _init_stat_15319856_13556(){
   cci_Schema_impl::enter_fun(sos_Id::make(sos_Container::make(15319856),57728),(cci_Fun)_univ_15319856_57728);
   cci_Schema_impl::enter_fun(sos_Id::make(sos_Container::make(15319856),57792),(cci_Fun)_univ_15319856_57792);
   cci_Schema_impl::enter_fun(sos_Id::make(sos_Container::make(15319856),57856),(cci_Fun)_univ_15319856_57856);
}
_sos_Ordered_object *__sos_Ordered_object_obj;
static void _init_new_15319856_13556(){
   cci_Schema_impl::enter_make_obj(_sos_Object_type,_sos_Ordered_object_type,(_sos_Object*)__sos_Ordered_object_obj);
   cci_Schema_impl::enter_make_obj(_sos_Ordered_object_type,_sos_Ordered_object_type,(_sos_Ordered_object*)__sos_Ordered_object_obj);
}
sos_Ordered_object::operator sos_Object(){return(sos_Object::make(_tpid,_ref));}
sos_Ordered_object sos_Ordered_object::make(sos_Typed_id&p){
   sos_Ordered_object o; o._tpid=p;
   o._ref=_sos_Ordered_object::_make(p); return o;}
sos_Ordered_object sos_Ordered_object::make(sos_Root_class& o){return sos_Ordered_object::make(o.typed_id());}
   sos_Offset sos_Ordered_object::_size(){return _ref->_size();}
sos_Ordered_object sos_Ordered_object::create(sos_Container _cnt){
   sos_Ordered_object _x=sos_Ordered_object::make(sos_Typed_id::allocate(sos_Ordered_object_type,_cnt,8));
   _x._ref->_create(_x._tpid);
   return _x;
}
sos_Ordered_object sos_Ordered_object::copy(sos_Ordered_object y,sos_Container cnt){
   sos_Ordered_object x=sos_Ordered_object::make(sos_Typed_id::allocate(sos_Ordered_object_type,cnt,8));
   x._ref->_copy(x._tpid,y);
   x.assign(y);
   return x;
}
sos_Ordered_object sos_Ordered_object::clone(sos_Ordered_object o,sos_Container cnt){
   return sos_Ordered_object::make (o._ref->_clone(o._tpid,cnt));
}
void sos_Ordered_object::destroy(){(_ref->destroy(_tpid));}
void sos_Ordered_object::assign(sos_Object source){(_ref->assign(_tpid,source));}
sos_Bool sos_Ordered_object::equal(sos_Object o,sos_Eq_kind eq_kind){return (_ref->equal(_tpid,o,eq_kind));}
sos_Int sos_Ordered_object::hash_value(){return (_ref->hash_value(_tpid));}
sos_Comp_result sos_Ordered_object::compare(sos_Ordered_object _p1){return (_ref->compare(_tpid,_p1));}
sos_Bool sos_Ordered_object::operator<(sos_Ordered_object _p1){return (_ref->__less(_tpid,_p1));}
sos_Bool sos_Ordered_object::operator<=(sos_Ordered_object _p1){return (_ref->__less_equal(_tpid,_p1));}
sos_Bool sos_Ordered_object::operator>(sos_Ordered_object _p1){return (_ref->__greater(_tpid,_p1));}
sos_Bool sos_Ordered_object::operator>=(sos_Ordered_object _p1){return (_ref->__greater_equal(_tpid,_p1));}
sos_Type sos_Ordered_object::type(){return (_ref->type(_tpid));}
sos_Bool sos_Ordered_object::has_type(sos_Type _p1){return (_ref->has_type(_tpid,_p1));}
sos_Bool sos_Ordered_object::isa(sos_Type _p1){return (_ref->isa(_tpid,_p1));}
sos_Bool sos_Ordered_object::is_some(sos_Type _p1){return (_ref->is_some(_tpid,_p1));}
sos_Bool sos_Ordered_object::is_value(){return (_ref->is_value(_tpid));}
sos_Int sos_Ordered_object::size(){return (_ref->size(_tpid));}
sos_Bool sos_Ordered_object::identical(sos_Object _p1){return (_ref->identical(_tpid,_p1));}
sos_Bool sos_Ordered_object::operator==(sos_Object _p1){return (_ref->__equal(_tpid,_p1));}
sos_Bool sos_Ordered_object::operator!=(sos_Object _p1){return (_ref->__not_equal(_tpid,_p1));}
sos_Bool sos_Ordered_object::like(sos_Object _p1){return (_ref->like(_tpid,_p1));}
sos_Comp_result sos_Ordered_object::compare_ids(sos_Object _p1){return (_ref->compare_ids(_tpid,_p1));}
void sos_Ordered_object::local_assign(sos_Ordered_object x,sos_Ordered_object y){(_sos_Ordered_object::local_assign(x,y));}
sos_Bool sos_Ordered_object::local_equal(sos_Ordered_object x,sos_Ordered_object y,sos_Eq_kind eq_kind){return (_sos_Ordered_object::local_equal(x,y,eq_kind));}
sos_Int sos_Ordered_object::local_hash_value(sos_Ordered_object x){return (_sos_Ordered_object::local_hash_value(x));}
_sos_Scalar_object* _sos_Scalar_object::_make(sos_Typed_id &tpid)
{  return (_sos_Scalar_object*)cci_Schema_impl::get_make_obj(_sos_Scalar_object_type,tpid.get_tp());
}
sos_Offset _sos_Scalar_object::_size(){return 8;}
void _sos_Scalar_object::_create(sos_Typed_id&_tpid){
   sos_Scalar_object _x=sos_Scalar_object::make(_tpid,this);
_sos_Scalar_object::local_initialize(_x);
}
void _sos_Scalar_object::_copy(sos_Typed_id&_tpid,sos_Scalar_object y){
   sos_Scalar_object x=sos_Scalar_object::make(_tpid,this);
_sos_Scalar_object::local_initialize(x);
}
sos_Object _sos_Scalar_object::_clone(sos_Typed_id&_tpid,sos_Container cnt){
   sos_Scalar_object _x=sos_Scalar_object::make(_tpid,this);
   return sos_Scalar_object::copy(_x,cnt);}
void _sos_Scalar_object::destroy(sos_Typed_id&_tpid){
   _sos_Scalar_object::local_finalize(sos_Scalar_object::make(_tpid,this));
   _tpid.container().deallocate(_tpid.offset(),8);}
void _sos_Scalar_object::assign(sos_Typed_id&_tpid,sos_Object o){
   sos_Scalar_object x=sos_Scalar_object::make(_tpid,this);
   _sos_Object::local_assign(x,o);
   _sos_Scalar_object::local_assign(x,o);
}
sos_Bool _sos_Scalar_object::equal(sos_Typed_id&_tpid,sos_Object o,sos_Eq_kind eq_kind){
   sos_Scalar_object x=sos_Scalar_object::make(_tpid,this);
   if (! _sos_Object::local_equal(x,o,eq_kind)) return FALSE;
   if (! _sos_Scalar_object::local_equal(x,o,eq_kind)) return FALSE;
   return TRUE;}
sos_Int _sos_Scalar_object::hash_value(sos_Typed_id&_tpid){
   sos_Scalar_object x=sos_Scalar_object::make(_tpid,this);
   sos_Int result=0;
   result ^= _sos_Object::local_hash_value(x);
   result ^= _sos_Scalar_object::local_hash_value(x);
   return result;}
static sos_Object _univ_15319856_58112(sos_Object o,sos_Object_Array){
   sos_Scalar_object::make (o).destroy();
   return NO_OBJECT;}
static sos_Object _univ_15319856_58176(sos_Object o,sos_Object_Array p){
   sos_Object o1=p[0];
   sos_Scalar_object::make (o).assign(sos_Object::make(o1));
   return NO_OBJECT;}
static sos_Object _univ_15319856_58240(sos_Object o,sos_Object_Array p){
   sos_Object o1=p[0], o2=p[1];
   return ::make_sos_Bool_object(sos_Scalar_object::make (o).equal(sos_Object::make(o1),::make_sos_Eq_kind(o2)));}
static sos_Object _univ_15319856_58304(sos_Object o,sos_Object_Array){
   return ::make_sos_Int_object(sos_Scalar_object::make (o).hash_value());}
static void _init_meth_15319856_21084(){
   cci_Schema_impl::enter_fun(sos_Id::make(sos_Container::make(15319856),58112),(cci_Fun)_univ_15319856_58112);
   cci_Schema_impl::enter_fun(sos_Id::make(sos_Container::make(15319856),58176),(cci_Fun)_univ_15319856_58176);
   cci_Schema_impl::enter_fun(sos_Id::make(sos_Container::make(15319856),58240),(cci_Fun)_univ_15319856_58240);
   cci_Schema_impl::enter_fun(sos_Id::make(sos_Container::make(15319856),58304),(cci_Fun)_univ_15319856_58304);
}
static void _init_comp_15319856_21084(){
}
static sos_Object _univ_15319856_58368(sos_Object,sos_Object_Array p){
   sos_Object o1=p[0];
   return sos_Object::make(sos_Scalar_object::create(::make_sos_Container(o1)));}
static sos_Object _univ_15319856_58432(sos_Object,sos_Object_Array p){
   sos_Object o1=p[0], o2=p[1];
   return sos_Object::make(sos_Scalar_object::copy(sos_Scalar_object::make(o1),::make_sos_Container(o2)));}
static sos_Object _univ_15319856_58496(sos_Object,sos_Object_Array p){
   sos_Object o1=p[0], o2=p[1];
   return sos_Object::make(sos_Scalar_object::clone(sos_Scalar_object::make(o1),::make_sos_Container(o2)));}
static void _init_stat_15319856_21084(){
   cci_Schema_impl::enter_fun(sos_Id::make(sos_Container::make(15319856),58368),(cci_Fun)_univ_15319856_58368);
   cci_Schema_impl::enter_fun(sos_Id::make(sos_Container::make(15319856),58432),(cci_Fun)_univ_15319856_58432);
   cci_Schema_impl::enter_fun(sos_Id::make(sos_Container::make(15319856),58496),(cci_Fun)_univ_15319856_58496);
}
_sos_Scalar_object *__sos_Scalar_object_obj;
static void _init_new_15319856_21084(){
   cci_Schema_impl::enter_make_obj(_sos_Object_type,_sos_Scalar_object_type,(_sos_Object*)__sos_Scalar_object_obj);
   cci_Schema_impl::enter_make_obj(_sos_Scalar_object_type,_sos_Scalar_object_type,(_sos_Scalar_object*)__sos_Scalar_object_obj);
}
sos_Scalar_object::operator sos_Object(){return(sos_Object::make(_tpid,_ref));}
sos_Scalar_object sos_Scalar_object::make(sos_Typed_id&p){
   sos_Scalar_object o; o._tpid=p;
   o._ref=_sos_Scalar_object::_make(p); return o;}
sos_Scalar_object sos_Scalar_object::make(sos_Root_class& o){return sos_Scalar_object::make(o.typed_id());}
   sos_Offset sos_Scalar_object::_size(){return _ref->_size();}
sos_Scalar_object sos_Scalar_object::create(sos_Container _cnt){
   sos_Scalar_object _x=sos_Scalar_object::make(sos_Typed_id::allocate(sos_Scalar_object_type,_cnt,8));
   _x._ref->_create(_x._tpid);
   return _x;
}
sos_Scalar_object sos_Scalar_object::copy(sos_Scalar_object y,sos_Container cnt){
   sos_Scalar_object x=sos_Scalar_object::make(sos_Typed_id::allocate(sos_Scalar_object_type,cnt,8));
   x._ref->_copy(x._tpid,y);
   x.assign(y);
   return x;
}
sos_Scalar_object sos_Scalar_object::clone(sos_Scalar_object o,sos_Container cnt){
   return sos_Scalar_object::make (o._ref->_clone(o._tpid,cnt));
}
void sos_Scalar_object::destroy(){(_ref->destroy(_tpid));}
void sos_Scalar_object::assign(sos_Object source){(_ref->assign(_tpid,source));}
sos_Bool sos_Scalar_object::equal(sos_Object o,sos_Eq_kind eq_kind){return (_ref->equal(_tpid,o,eq_kind));}
sos_Int sos_Scalar_object::hash_value(){return (_ref->hash_value(_tpid));}
void sos_Scalar_object::local_initialize(sos_Scalar_object _p1){(_sos_Scalar_object::local_initialize(_p1));}
void sos_Scalar_object::local_finalize(sos_Scalar_object _p1){(_sos_Scalar_object::local_finalize(_p1));}
void sos_Scalar_object::local_assign(sos_Scalar_object _p1,sos_Object _p2){(_sos_Scalar_object::local_assign(_p1,_p2));}
sos_Bool sos_Scalar_object::local_equal(sos_Scalar_object _p1,sos_Object _p2,sos_Eq_kind _p3){return (_sos_Scalar_object::local_equal(_p1,_p2,_p3));}
sos_Int sos_Scalar_object::local_hash_value(sos_Scalar_object _p1){return (_sos_Scalar_object::local_hash_value(_p1));}
sos_Type sos_Scalar_object::type(){return (_ref->type(_tpid));}
sos_Bool sos_Scalar_object::has_type(sos_Type _p1){return (_ref->has_type(_tpid,_p1));}
sos_Bool sos_Scalar_object::isa(sos_Type _p1){return (_ref->isa(_tpid,_p1));}
sos_Bool sos_Scalar_object::is_some(sos_Type _p1){return (_ref->is_some(_tpid,_p1));}
sos_Bool sos_Scalar_object::is_value(){return (_ref->is_value(_tpid));}
sos_Int sos_Scalar_object::size(){return (_ref->size(_tpid));}
sos_Bool sos_Scalar_object::identical(sos_Object _p1){return (_ref->identical(_tpid,_p1));}
sos_Bool sos_Scalar_object::operator==(sos_Object _p1){return (_ref->__equal(_tpid,_p1));}
sos_Bool sos_Scalar_object::operator!=(sos_Object _p1){return (_ref->__not_equal(_tpid,_p1));}
sos_Bool sos_Scalar_object::like(sos_Object _p1){return (_ref->like(_tpid,_p1));}
sos_Comp_result sos_Scalar_object::compare_ids(sos_Object _p1){return (_ref->compare_ids(_tpid,_p1));}
_sos_String* _sos_String::_make(sos_Typed_id &tpid)
{  return (_sos_String*)cci_Schema_impl::get_make_obj(_sos_String_type,tpid.get_tp());
}
sos_Offset _sos_String::_size(){return 16;}
void _sos_String::_create(sos_Typed_id&_tpid){
   sos_String _x=sos_String::make(_tpid,this);
_sos_String::local_initialize(_x);
}
void _sos_String::_copy(sos_Typed_id&_tpid,sos_String y){
   sos_String x=sos_String::make(_tpid,this);
_sos_String::local_initialize(x);
}
sos_Object _sos_String::_clone(sos_Typed_id&_tpid,sos_Container cnt){
   sos_String _x=sos_String::make(_tpid,this);
   return sos_String::copy(_x,cnt);}
void _sos_String::destroy(sos_Typed_id&_tpid){
   _sos_String::local_finalize(sos_String::make(_tpid,this));
   _tpid.container().deallocate(_tpid.offset(),16);}
void _sos_String::assign(sos_Typed_id&_tpid,sos_Object o){
   sos_String x=sos_String::make(_tpid,this);
   _sos_Object::local_assign(x,o);
   _sos_Ordered_object::local_assign(x,o);
   _sos_String::local_assign(x,o);
}
sos_Bool _sos_String::equal(sos_Typed_id&_tpid,sos_Object o,sos_Eq_kind eq_kind){
   sos_String x=sos_String::make(_tpid,this);
   if (! _sos_Object::local_equal(x,o,eq_kind)) return FALSE;
   if (! _sos_Ordered_object::local_equal(x,o,eq_kind)) return FALSE;
   if (! _sos_String::local_equal(x,o,eq_kind)) return FALSE;
   return TRUE;}
sos_Int _sos_String::hash_value(sos_Typed_id&_tpid){
   sos_String x=sos_String::make(_tpid,this);
   sos_Int result=0;
   result ^= _sos_Object::local_hash_value(x);
   result ^= _sos_Ordered_object::local_hash_value(x);
   result ^= _sos_String::local_hash_value(x);
   return result;}
sos_Int _sos_String::get_length(sos_Typed_id&_tpid)
{  union {sos_Int x; char c[4];} u; sos_Int a;
   _tpid.container().read(_tpid.offset()+_offset_sos_String()+0,4,&u);
   bcopy_to_sos_Int(&a,&u);
   return a;}
void _sos_String::set_length(sos_Typed_id&_tpid,sos_Int a){
   union {sos_Int x; char c[4];} u;
   bcopy_from_sos_Int(&a,&u);
   _tpid.container().write(_tpid.offset() + _offset_sos_String() + 0,4,&u);
}
sos_Offset _sos_String::get_address(sos_Typed_id&_tpid)
{  union {sos_Offset x; char c[4];} u; sos_Offset a;
   _tpid.container().read(_tpid.offset()+_offset_sos_String()+4,4,&u);
   bcopy_to_sos_Offset(&a,&u);
   return a;}
void _sos_String::set_address(sos_Typed_id&_tpid,sos_Offset a){
   union {sos_Offset x; char c[4];} u;
   bcopy_from_sos_Offset(&a,&u);
   _tpid.container().write(_tpid.offset() + _offset_sos_String() + 4,4,&u);
}
static sos_Object _univ_15319856_58880(sos_Object o,sos_Object_Array){
   sos_String::make (o).destroy();
   return NO_OBJECT;}
static sos_Object _univ_15319856_58944(sos_Object o,sos_Object_Array p){
   sos_Object o1=p[0];
   sos_String::make (o).assign(sos_Object::make(o1));
   return NO_OBJECT;}
static sos_Object _univ_15319856_59008(sos_Object o,sos_Object_Array p){
   sos_Object o1=p[0], o2=p[1];
   return ::make_sos_Bool_object(sos_String::make (o).equal(sos_Object::make(o1),::make_sos_Eq_kind(o2)));}
static sos_Object _univ_15319856_59072(sos_Object o,sos_Object_Array){
   return ::make_sos_Int_object(sos_String::make (o).hash_value());}
static sos_Object _univ_15319856_59136(sos_Object o,sos_Object_Array){
   return ::make_sos_Cstring_object(sos_String::make (o).make_Cstring());}
static sos_Object _univ_15319856_59200(sos_Object o,sos_Object_Array p){
   sos_Object o1=p[0];
   sos_String::make (o).assign_Cstring(::make_sos_Cstring(o1));
   return NO_OBJECT;}
static sos_Object _univ_15319856_59264(sos_Object o,sos_Object_Array p){
   sos_Object o1=p[0];
   sos_String::make (o).operator+=(sos_String::make(o1));
   return NO_OBJECT;}
static sos_Object _univ_15319856_59328(sos_Object o,sos_Object_Array){
   return ::make_sos_Int_object(sos_String::make (o).size());}
static sos_Object _univ_15319856_59392(sos_Object o,sos_Object_Array p){
   sos_Object o1=p[0];
   return ::make_sos_Comp_result_object(sos_String::make (o).compare(sos_Ordered_object::make(o1)));}
static void _init_meth_15319856_28364(){
   cci_Schema_impl::enter_fun(sos_Id::make(sos_Container::make(15319856),58880),(cci_Fun)_univ_15319856_58880);
   cci_Schema_impl::enter_fun(sos_Id::make(sos_Container::make(15319856),58944),(cci_Fun)_univ_15319856_58944);
   cci_Schema_impl::enter_fun(sos_Id::make(sos_Container::make(15319856),59008),(cci_Fun)_univ_15319856_59008);
   cci_Schema_impl::enter_fun(sos_Id::make(sos_Container::make(15319856),59072),(cci_Fun)_univ_15319856_59072);
   cci_Schema_impl::enter_fun(sos_Id::make(sos_Container::make(15319856),59136),(cci_Fun)_univ_15319856_59136);
   cci_Schema_impl::enter_fun(sos_Id::make(sos_Container::make(15319856),59200),(cci_Fun)_univ_15319856_59200);
   cci_Schema_impl::enter_fun(sos_Id::make(sos_Container::make(15319856),59264),(cci_Fun)_univ_15319856_59264);
   cci_Schema_impl::enter_fun(sos_Id::make(sos_Container::make(15319856),59328),(cci_Fun)_univ_15319856_59328);
   cci_Schema_impl::enter_fun(sos_Id::make(sos_Container::make(15319856),59392),(cci_Fun)_univ_15319856_59392);
}
static sos_Object _univ_15319856_59456(sos_Object o,sos_Object_Array){
   return ::make_sos_Int_object(sos_String::make (o).get_length());}
static void _init_comp_15319856_28364(){
   cci_Schema_impl::enter_fun(sos_Id::make(sos_Container::make(15319856),59456),(cci_Fun)_univ_15319856_59456);
}
static sos_Object _univ_15319856_59712(sos_Object,sos_Object_Array p){
   sos_Object o1=p[0];
   return sos_Object::make(sos_String::create(::make_sos_Container(o1)));}
static sos_Object _univ_15319856_59776(sos_Object,sos_Object_Array p){
   sos_Object o1=p[0], o2=p[1];
   return sos_Object::make(sos_String::copy(sos_String::make(o1),::make_sos_Container(o2)));}
static sos_Object _univ_15319856_59840(sos_Object,sos_Object_Array p){
   sos_Object o1=p[0], o2=p[1];
   return sos_Object::make(sos_String::clone(sos_String::make(o1),::make_sos_Container(o2)));}
static void _init_stat_15319856_28364(){
   cci_Schema_impl::enter_fun(sos_Id::make(sos_Container::make(15319856),59712),(cci_Fun)_univ_15319856_59712);
   cci_Schema_impl::enter_fun(sos_Id::make(sos_Container::make(15319856),59776),(cci_Fun)_univ_15319856_59776);
   cci_Schema_impl::enter_fun(sos_Id::make(sos_Container::make(15319856),59840),(cci_Fun)_univ_15319856_59840);
}
_sos_String *__sos_String_obj;
static void _init_new_15319856_28364(){
   cci_Schema_impl::enter_make_obj(_sos_Object_type,_sos_String_type,(_sos_Object*)__sos_String_obj);
   cci_Schema_impl::enter_make_obj(_sos_Ordered_object_type,_sos_String_type,(_sos_Ordered_object*)__sos_String_obj);
   cci_Schema_impl::enter_make_obj(_sos_String_type,_sos_String_type,(_sos_String*)__sos_String_obj);
}
sos_String::operator sos_Object(){return(sos_Object::make(_tpid,_ref));}
sos_String::operator sos_Ordered_object(){return(sos_Ordered_object::make(_tpid,_ref));}
sos_String sos_String::make(sos_Typed_id&p){
   sos_String o; o._tpid=p;
   o._ref=_sos_String::_make(p); return o;}
sos_String sos_String::make(sos_Root_class& o){return sos_String::make(o.typed_id());}
   sos_Offset sos_String::_size(){return _ref->_size();}
sos_String sos_String::create(sos_Container _cnt){
   sos_String _x=sos_String::make(sos_Typed_id::allocate(sos_String_type,_cnt,16));
   _x._ref->_create(_x._tpid);
   return _x;
}
sos_String sos_String::copy(sos_String y,sos_Container cnt){
   sos_String x=sos_String::make(sos_Typed_id::allocate(sos_String_type,cnt,16));
   x._ref->_copy(x._tpid,y);
   x.assign(y);
   return x;
}
sos_String sos_String::clone(sos_String o,sos_Container cnt){
   return sos_String::make (o._ref->_clone(o._tpid,cnt));
}
void sos_String::destroy(){(_ref->destroy(_tpid));}
sos_Int sos_String::hash_value(){return (_ref->hash_value(_tpid));}
sos_Cstring sos_String::make_Cstring(){return (_ref->make_Cstring(_tpid));}
void sos_String::operator+=(sos_String _p1){(_ref->__plus_assign(_tpid,_p1));}
sos_Comp_result sos_String::compare(sos_Ordered_object _p1){return (_ref->compare(_tpid,_p1));}
sos_Int sos_String::get_length(){return (_ref->get_length(_tpid));}
void sos_String::set_length(sos_Int _p1){(_ref->set_length(_tpid,_p1));}
void sos_String::local_assign(sos_String _p1,sos_Object _p2){(_sos_String::local_assign(_p1,_p2));}
sos_Bool sos_String::local_equal(sos_String _p1,sos_Object _p2,sos_Eq_kind _p3){return (_sos_String::local_equal(_p1,_p2,_p3));}
sos_Bool sos_String::operator<(sos_Ordered_object _p1){return (_ref->__less(_tpid,_p1));}
sos_Bool sos_String::operator<=(sos_Ordered_object _p1){return (_ref->__less_equal(_tpid,_p1));}
sos_Bool sos_String::operator>(sos_Ordered_object _p1){return (_ref->__greater(_tpid,_p1));}
sos_Bool sos_String::operator>=(sos_Ordered_object _p1){return (_ref->__greater_equal(_tpid,_p1));}
sos_Bool sos_String::has_type(sos_Type _p1){return (_ref->has_type(_tpid,_p1));}
sos_Bool sos_String::isa(sos_Type _p1){return (_ref->isa(_tpid,_p1));}
sos_Bool sos_String::operator==(sos_Object _p1){return (_ref->__equal(_tpid,_p1));}
sos_Bool sos_String::operator!=(sos_Object _p1){return (_ref->__not_equal(_tpid,_p1));}
void sos_String::assign(sos_Object source){(_ref->assign(_tpid,source));}
sos_Bool sos_String::equal(sos_Object o,sos_Eq_kind eq_kind){return (_ref->equal(_tpid,o,eq_kind));}
void sos_String::assign_Cstring(sos_Cstring _p1){(_ref->assign_Cstring(_tpid,_p1));}
sos_Int sos_String::size(){return (_ref->size(_tpid));}
sos_Offset sos_String::get_address(){return (_ref->get_address(_tpid));}
void sos_String::set_address(sos_Offset _p1){(_ref->set_address(_tpid,_p1));}
void sos_String::local_initialize(sos_String _p1){(_sos_String::local_initialize(_p1));}
void sos_String::local_finalize(sos_String _p1){(_sos_String::local_finalize(_p1));}
sos_Int sos_String::local_hash_value(sos_String _p1){return (_sos_String::local_hash_value(_p1));}
sos_Type sos_String::type(){return (_ref->type(_tpid));}
sos_Bool sos_String::is_some(sos_Type _p1){return (_ref->is_some(_tpid,_p1));}
sos_Bool sos_String::is_value(){return (_ref->is_value(_tpid));}
sos_Bool sos_String::identical(sos_Object _p1){return (_ref->identical(_tpid,_p1));}
sos_Bool sos_String::like(sos_Object _p1){return (_ref->like(_tpid,_p1));}
sos_Comp_result sos_String::compare_ids(sos_Object _p1){return (_ref->compare_ids(_tpid,_p1));}
_sos_Named* _sos_Named::_make(sos_Typed_id &tpid)
{  return (_sos_Named*)cci_Schema_impl::get_make_obj(_sos_Named_type,tpid.get_tp());
}
sos_Offset _sos_Named::_size(){return 8;}
void _sos_Named::_create(sos_Typed_id&_tpid){
   sos_Named _x=sos_Named::make(_tpid,this);
}
void _sos_Named::_copy(sos_Typed_id&_tpid,sos_Named y){
   sos_Named x=sos_Named::make(_tpid,this);
}
sos_Object _sos_Named::_clone(sos_Typed_id&_tpid,sos_Container cnt){
   sos_Named _x=sos_Named::make(_tpid,this);
   return sos_Named::copy(_x,cnt);}
void _sos_Named::destroy(sos_Typed_id&_tpid){
   _tpid.container().deallocate(_tpid.offset(),8);}
void _sos_Named::assign(sos_Typed_id&_tpid,sos_Object o){
   sos_Named x=sos_Named::make(_tpid,this);
   _sos_Object::local_assign(x,o);
   _sos_Named::local_assign(x,o);
}
void _sos_Named::local_assign(sos_Named x,sos_Object o){
}
sos_Bool _sos_Named::equal(sos_Typed_id&_tpid,sos_Object o,sos_Eq_kind eq_kind){
   sos_Named x=sos_Named::make(_tpid,this);
   if (! _sos_Object::local_equal(x,o,eq_kind)) return FALSE;
   if (! _sos_Named::local_equal(x,o,eq_kind)) return FALSE;
   return TRUE;}
sos_Bool _sos_Named::local_equal(sos_Named,sos_Object,sos_Eq_kind) { return TRUE;}
sos_Int _sos_Named::hash_value(sos_Typed_id&_tpid){
   sos_Named x=sos_Named::make(_tpid,this);
   sos_Int result=0;
   result ^= _sos_Object::local_hash_value(x);
   result ^= _sos_Named::local_hash_value(x);
   return result;}
sos_Int _sos_Named::local_hash_value(sos_Named x){
   return x.container().hash_value(x.offset()+x._ref->_offset_sos_Named(),0);}
sos_String _sos_Named::get_name(sos_Typed_id&) {
   err_raise_abstract_method ("sos_Named::get_name"); 
   return sos_String::make(NO_OBJECT); }
void _sos_Named::set_name(sos_Typed_id&,sos_String ) {
   err_raise_abstract_method ("sos_Named::set_name"); }
static sos_Object _univ_15319856_60224(sos_Object o,sos_Object_Array){
   sos_Named::make (o).destroy();
   return NO_OBJECT;}
static sos_Object _univ_15319856_60288(sos_Object o,sos_Object_Array p){
   sos_Object o1=p[0];
   sos_Named::make (o).assign(sos_Object::make(o1));
   return NO_OBJECT;}
static sos_Object _univ_15319856_60352(sos_Object o,sos_Object_Array p){
   sos_Object o1=p[0], o2=p[1];
   return ::make_sos_Bool_object(sos_Named::make (o).equal(sos_Object::make(o1),::make_sos_Eq_kind(o2)));}
static sos_Object _univ_15319856_60416(sos_Object o,sos_Object_Array){
   return ::make_sos_Int_object(sos_Named::make (o).hash_value());}
static sos_Object _univ_15319856_60480(sos_Object o,sos_Object_Array){
   return sos_Object::make(sos_Named::make (o).get_name());}
static sos_Object _univ_15319856_60544(sos_Object o,sos_Object_Array p){
   sos_Object o1=p[0];
   sos_Named::make (o).set_name(sos_String::make(o1));
   return NO_OBJECT;}
static void _init_meth_15319856_39164(){
   cci_Schema_impl::enter_fun(sos_Id::make(sos_Container::make(15319856),60224),(cci_Fun)_univ_15319856_60224);
   cci_Schema_impl::enter_fun(sos_Id::make(sos_Container::make(15319856),60288),(cci_Fun)_univ_15319856_60288);
   cci_Schema_impl::enter_fun(sos_Id::make(sos_Container::make(15319856),60352),(cci_Fun)_univ_15319856_60352);
   cci_Schema_impl::enter_fun(sos_Id::make(sos_Container::make(15319856),60416),(cci_Fun)_univ_15319856_60416);
   cci_Schema_impl::enter_fun(sos_Id::make(sos_Container::make(15319856),60480),(cci_Fun)_univ_15319856_60480);
   cci_Schema_impl::enter_fun(sos_Id::make(sos_Container::make(15319856),60544),(cci_Fun)_univ_15319856_60544);
}
static void _init_comp_15319856_39164(){
}
static sos_Object _univ_15319856_60608(sos_Object,sos_Object_Array p){
   sos_Object o1=p[0];
   return sos_Object::make(sos_Named::create(::make_sos_Container(o1)));}
static sos_Object _univ_15319856_60672(sos_Object,sos_Object_Array p){
   sos_Object o1=p[0], o2=p[1];
   return sos_Object::make(sos_Named::copy(sos_Named::make(o1),::make_sos_Container(o2)));}
static sos_Object _univ_15319856_60736(sos_Object,sos_Object_Array p){
   sos_Object o1=p[0], o2=p[1];
   return sos_Object::make(sos_Named::clone(sos_Named::make(o1),::make_sos_Container(o2)));}
static void _init_stat_15319856_39164(){
   cci_Schema_impl::enter_fun(sos_Id::make(sos_Container::make(15319856),60608),(cci_Fun)_univ_15319856_60608);
   cci_Schema_impl::enter_fun(sos_Id::make(sos_Container::make(15319856),60672),(cci_Fun)_univ_15319856_60672);
   cci_Schema_impl::enter_fun(sos_Id::make(sos_Container::make(15319856),60736),(cci_Fun)_univ_15319856_60736);
}
_sos_Named *__sos_Named_obj;
static void _init_new_15319856_39164(){
   cci_Schema_impl::enter_make_obj(_sos_Object_type,_sos_Named_type,(_sos_Object*)__sos_Named_obj);
   cci_Schema_impl::enter_make_obj(_sos_Named_type,_sos_Named_type,(_sos_Named*)__sos_Named_obj);
}
sos_Named::operator sos_Object(){return(sos_Object::make(_tpid,_ref));}
sos_Named sos_Named::make(sos_Typed_id&p){
   sos_Named o; o._tpid=p;
   o._ref=_sos_Named::_make(p); return o;}
sos_Named sos_Named::make(sos_Root_class& o){return sos_Named::make(o.typed_id());}
   sos_Offset sos_Named::_size(){return _ref->_size();}
sos_Named sos_Named::create(sos_Container _cnt){
   sos_Named _x=sos_Named::make(sos_Typed_id::allocate(sos_Named_type,_cnt,8));
   _x._ref->_create(_x._tpid);
   return _x;
}
sos_Named sos_Named::copy(sos_Named y,sos_Container cnt){
   sos_Named x=sos_Named::make(sos_Typed_id::allocate(sos_Named_type,cnt,8));
   x._ref->_copy(x._tpid,y);
   x.assign(y);
   return x;
}
sos_Named sos_Named::clone(sos_Named o,sos_Container cnt){
   return sos_Named::make (o._ref->_clone(o._tpid,cnt));
}
void sos_Named::destroy(){(_ref->destroy(_tpid));}
void sos_Named::assign(sos_Object source){(_ref->assign(_tpid,source));}
sos_Bool sos_Named::equal(sos_Object o,sos_Eq_kind eq_kind){return (_ref->equal(_tpid,o,eq_kind));}
sos_Int sos_Named::hash_value(){return (_ref->hash_value(_tpid));}
sos_String sos_Named::get_name(){return (_ref->get_name(_tpid));}
void sos_Named::set_name(sos_String _p1){(_ref->set_name(_tpid,_p1));}
sos_Type sos_Named::type(){return (_ref->type(_tpid));}
sos_Bool sos_Named::has_type(sos_Type _p1){return (_ref->has_type(_tpid,_p1));}
sos_Bool sos_Named::isa(sos_Type _p1){return (_ref->isa(_tpid,_p1));}
sos_Bool sos_Named::is_some(sos_Type _p1){return (_ref->is_some(_tpid,_p1));}
sos_Bool sos_Named::is_value(){return (_ref->is_value(_tpid));}
sos_Int sos_Named::size(){return (_ref->size(_tpid));}
sos_Bool sos_Named::identical(sos_Object _p1){return (_ref->identical(_tpid,_p1));}
sos_Bool sos_Named::operator==(sos_Object _p1){return (_ref->__equal(_tpid,_p1));}
sos_Bool sos_Named::operator!=(sos_Object _p1){return (_ref->__not_equal(_tpid,_p1));}
sos_Bool sos_Named::like(sos_Object _p1){return (_ref->like(_tpid,_p1));}
sos_Comp_result sos_Named::compare_ids(sos_Object _p1){return (_ref->compare_ids(_tpid,_p1));}
void sos_Named::local_assign(sos_Named x,sos_Named y){(_sos_Named::local_assign(x,y));}
sos_Bool sos_Named::local_equal(sos_Named x,sos_Named y,sos_Eq_kind eq_kind){return (_sos_Named::local_equal(x,y,eq_kind));}
sos_Int sos_Named::local_hash_value(sos_Named x){return (_sos_Named::local_hash_value(x));}
_sos_Type* _sos_Type::_make(sos_Typed_id &tpid)
{  return (_sos_Type*)cci_Schema_impl::get_make_obj(_sos_Type_type,tpid.get_tp());
}
sos_Offset _sos_Type::_size(){return 28;}
void _sos_Type::_create(sos_Typed_id&_tpid){
   sos_Type _x=sos_Type::make(_tpid,this);
}
void _sos_Type::_copy(sos_Typed_id&_tpid,sos_Type y){
   sos_Type x=sos_Type::make(_tpid,this);
}
sos_Object _sos_Type::_clone(sos_Typed_id&_tpid,sos_Container cnt){
   sos_Type _x=sos_Type::make(_tpid,this);
   return sos_Type::copy(_x,cnt);}
void _sos_Type::destroy(sos_Typed_id&_tpid){
   _tpid.container().deallocate(_tpid.offset(),28);}
void _sos_Type::assign(sos_Typed_id&_tpid,sos_Object o){
   sos_Type x=sos_Type::make(_tpid,this);
   _sos_Object::local_assign(x,o);
   _sos_Named::local_assign(x,o);
   _sos_Type::local_assign(x,o);
}
void _sos_Type::local_assign(sos_Type x,sos_Object o){
   sos_Type y=sos_Type::make(o);
   y.container().copy(y.offset()+y._ref->_offset_sos_Type(),20,x.container(),x.offset()+x._ref->_offset_sos_Type());}
sos_Bool _sos_Type::equal(sos_Typed_id&_tpid,sos_Object o,sos_Eq_kind eq_kind){
   sos_Type x=sos_Type::make(_tpid,this);
   if (! _sos_Object::local_equal(x,o,eq_kind)) return FALSE;
   if (! _sos_Named::local_equal(x,o,eq_kind)) return FALSE;
   if (! _sos_Type::local_equal(x,o,eq_kind)) return FALSE;
   return TRUE;}
sos_Bool _sos_Type::local_equal(sos_Type x,sos_Object o,sos_Eq_kind eq_kind){
   if (eq_kind==EQ_STRONG) {if (!o.has_type(sos_Type_type)) return FALSE;}
   else if (!o.isa(sos_Type_type)) return FALSE;
   sos_Type y=sos_Type::make(o);
   return (sos_Bool)x.container().equal(x.offset()+x._ref->_offset_sos_Type(),20,y.container(),y.offset()+y._ref->_offset_sos_Type());}
sos_Int _sos_Type::hash_value(sos_Typed_id&_tpid){
   sos_Type x=sos_Type::make(_tpid,this);
   sos_Int result=0;
   result ^= _sos_Object::local_hash_value(x);
   result ^= _sos_Named::local_hash_value(x);
   result ^= _sos_Type::local_hash_value(x);
   return result;}
sos_Int _sos_Type::local_hash_value(sos_Type x){
   return x.container().hash_value(x.offset()+x._ref->_offset_sos_Type(),20);}
sos_String _sos_Type::get_name(sos_Typed_id&_tpid)
{  union {sos_Typed_id x; char c[16];} u; sos_Typed_id a;
   _tpid.container().read(_tpid.offset()+_offset_sos_Type()+0,16,&u);
   bcopy_to_sos_Typed_id(&a,&u);
   return sos_String::make(a);}
void _sos_Type::set_name(sos_Typed_id&_tpid,sos_String a){
   union {sos_Typed_id x; char c[16];} u;
   sos_Typed_id x=a.typed_id();
   bcopy_from_sos_Typed_id(&x,&u);
   _tpid.container().write(_tpid.offset() + _offset_sos_Type() + 0,16,&u);
}
sos_Int _sos_Type::get_object_size(sos_Typed_id&_tpid)
{  union {sos_Int x; char c[4];} u; sos_Int a;
   _tpid.container().read(_tpid.offset()+_offset_sos_Type()+16,4,&u);
   bcopy_to_sos_Int(&a,&u);
   return a;}
void _sos_Type::set_object_size(sos_Typed_id&_tpid,sos_Int a){
   union {sos_Int x; char c[4];} u;
   bcopy_from_sos_Int(&a,&u);
   _tpid.container().write(_tpid.offset() + _offset_sos_Type() + 16,4,&u);
}
static sos_Object _univ_15319856_60992(sos_Object o,sos_Object_Array){
   sos_Type::make (o).destroy();
   return NO_OBJECT;}
static sos_Object _univ_15319856_61056(sos_Object o,sos_Object_Array p){
   sos_Object o1=p[0];
   sos_Type::make (o).assign(sos_Object::make(o1));
   return NO_OBJECT;}
static sos_Object _univ_15319856_61120(sos_Object o,sos_Object_Array p){
   sos_Object o1=p[0], o2=p[1];
   return ::make_sos_Bool_object(sos_Type::make (o).equal(sos_Object::make(o1),::make_sos_Eq_kind(o2)));}
static sos_Object _univ_15319856_61184(sos_Object o,sos_Object_Array){
   return ::make_sos_Int_object(sos_Type::make (o).hash_value());}
static sos_Object _univ_15319856_61248(sos_Object o,sos_Object_Array p){
   sos_Object o1=p[0];
   return ::make_sos_Bool_object(sos_Type::make (o).is_derived_from(sos_Type::make(o1)));}
static sos_Object _univ_15319856_61312(sos_Object o,sos_Object_Array p){
   sos_Object o1=p[0];
   return ::make_sos_Bool_object(sos_Type::make (o).is_derived_from_some(sos_Type::make(o1)));}
static sos_Object _univ_15319856_61376(sos_Object o,sos_Object_Array){
   return ::make_sos_Bool_object(sos_Type::make (o).is_scalar());}
static sos_Object _univ_15319856_61440(sos_Object o,sos_Object_Array){
   return sos_Object::make(sos_Type::make (o).base());}
static sos_Object _univ_15319856_61504(sos_Object o,sos_Object_Array){
   return sos_Object::make(sos_Type::make (o).root());}
static void _init_meth_15319856_45644(){
   cci_Schema_impl::enter_fun(sos_Id::make(sos_Container::make(15319856),60992),(cci_Fun)_univ_15319856_60992);
   cci_Schema_impl::enter_fun(sos_Id::make(sos_Container::make(15319856),61056),(cci_Fun)_univ_15319856_61056);
   cci_Schema_impl::enter_fun(sos_Id::make(sos_Container::make(15319856),61120),(cci_Fun)_univ_15319856_61120);
   cci_Schema_impl::enter_fun(sos_Id::make(sos_Container::make(15319856),61184),(cci_Fun)_univ_15319856_61184);
   cci_Schema_impl::enter_fun(sos_Id::make(sos_Container::make(15319856),61248),(cci_Fun)_univ_15319856_61248);
   cci_Schema_impl::enter_fun(sos_Id::make(sos_Container::make(15319856),61312),(cci_Fun)_univ_15319856_61312);
   cci_Schema_impl::enter_fun(sos_Id::make(sos_Container::make(15319856),61376),(cci_Fun)_univ_15319856_61376);
   cci_Schema_impl::enter_fun(sos_Id::make(sos_Container::make(15319856),61440),(cci_Fun)_univ_15319856_61440);
   cci_Schema_impl::enter_fun(sos_Id::make(sos_Container::make(15319856),61504),(cci_Fun)_univ_15319856_61504);
}
static sos_Object _univ_15319856_61568(sos_Object o,sos_Object_Array){
   return sos_Object::make(sos_Type::make (o).get_name());}
static sos_Object _univ_15319856_61632(sos_Object o,sos_Object_Array p){
   sos_Object o1=p[0];
   sos_Type::make (o).set_name(sos_String::make(o1));
   return NO_OBJECT;}
static sos_Object _univ_15319856_61696(sos_Object o,sos_Object_Array){
   return ::make_sos_Int_object(sos_Type::make (o).get_object_size());}
static sos_Object _univ_15319856_61760(sos_Object o,sos_Object_Array p){
   sos_Object o1=p[0];
   sos_Type::make (o).set_object_size(::make_sos_Int(o1));
   return NO_OBJECT;}
static void _init_comp_15319856_45644(){
   cci_Schema_impl::enter_fun(sos_Id::make(sos_Container::make(15319856),61568),(cci_Fun)_univ_15319856_61568);
   cci_Schema_impl::enter_fun(sos_Id::make(sos_Container::make(15319856),61632),(cci_Fun)_univ_15319856_61632);
   cci_Schema_impl::enter_fun(sos_Id::make(sos_Container::make(15319856),61696),(cci_Fun)_univ_15319856_61696);
   cci_Schema_impl::enter_fun(sos_Id::make(sos_Container::make(15319856),61760),(cci_Fun)_univ_15319856_61760);
}
static sos_Object _univ_15319856_61824(sos_Object,sos_Object_Array p){
   sos_Object o1=p[0];
   return sos_Object::make(sos_Type::create(::make_sos_Container(o1)));}
static sos_Object _univ_15319856_61888(sos_Object,sos_Object_Array p){
   sos_Object o1=p[0], o2=p[1];
   return sos_Object::make(sos_Type::copy(sos_Type::make(o1),::make_sos_Container(o2)));}
static sos_Object _univ_15319856_61952(sos_Object,sos_Object_Array p){
   sos_Object o1=p[0], o2=p[1];
   return sos_Object::make(sos_Type::clone(sos_Type::make(o1),::make_sos_Container(o2)));}
static void _init_stat_15319856_45644(){
   cci_Schema_impl::enter_fun(sos_Id::make(sos_Container::make(15319856),61824),(cci_Fun)_univ_15319856_61824);
   cci_Schema_impl::enter_fun(sos_Id::make(sos_Container::make(15319856),61888),(cci_Fun)_univ_15319856_61888);
   cci_Schema_impl::enter_fun(sos_Id::make(sos_Container::make(15319856),61952),(cci_Fun)_univ_15319856_61952);
}
_sos_Type *__sos_Type_obj;
static void _init_new_15319856_45644(){
   cci_Schema_impl::enter_make_obj(_sos_Object_type,_sos_Type_type,(_sos_Object*)__sos_Type_obj);
   cci_Schema_impl::enter_make_obj(_sos_Named_type,_sos_Type_type,(_sos_Named*)__sos_Type_obj);
   cci_Schema_impl::enter_make_obj(_sos_Type_type,_sos_Type_type,(_sos_Type*)__sos_Type_obj);
}
sos_Type::operator sos_Object(){return(sos_Object::make(_tpid,_ref));}
sos_Type::operator sos_Named(){return(sos_Named::make(_tpid,_ref));}
sos_Type sos_Type::make(sos_Typed_id&p){
   sos_Type o; o._tpid=p;
   o._ref=_sos_Type::_make(p); return o;}
sos_Type sos_Type::make(sos_Root_class& o){return sos_Type::make(o.typed_id());}
   sos_Offset sos_Type::_size(){return _ref->_size();}
sos_Type sos_Type::create(sos_Container _cnt){
   sos_Type _x=sos_Type::make(sos_Typed_id::allocate(sos_Type_type,_cnt,28));
   _x._ref->_create(_x._tpid);
   return _x;
}
sos_Type sos_Type::copy(sos_Type y,sos_Container cnt){
   sos_Type x=sos_Type::make(sos_Typed_id::allocate(sos_Type_type,cnt,28));
   x._ref->_copy(x._tpid,y);
   x.assign(y);
   return x;
}
sos_Type sos_Type::clone(sos_Type o,sos_Container cnt){
   return sos_Type::make (o._ref->_clone(o._tpid,cnt));
}
void sos_Type::destroy(){(_ref->destroy(_tpid));}
sos_Int sos_Type::hash_value(){return (_ref->hash_value(_tpid));}
sos_Bool sos_Type::is_derived_from(sos_Type _p1){return (_ref->is_derived_from(_tpid,_p1));}
sos_Bool sos_Type::is_derived_from_some(sos_Type _p1){return (_ref->is_derived_from_some(_tpid,_p1));}
sos_Bool sos_Type::is_scalar(){return (_ref->is_scalar(_tpid));}
sos_Type sos_Type::root(){return (_ref->root(_tpid));}
sos_String sos_Type::get_name(){return (_ref->get_name(_tpid));}
void sos_Type::set_name(sos_String _p1){(_ref->set_name(_tpid,_p1));}
sos_Bool sos_Type::has_type(sos_Type _p1){return (_ref->has_type(_tpid,_p1));}
sos_Bool sos_Type::isa(sos_Type _p1){return (_ref->isa(_tpid,_p1));}
sos_Bool sos_Type::operator==(sos_Object _p1){return (_ref->__equal(_tpid,_p1));}
sos_Bool sos_Type::operator!=(sos_Object _p1){return (_ref->__not_equal(_tpid,_p1));}
void sos_Type::local_assign(sos_Type x,sos_Type y){(_sos_Type::local_assign(x,y));}
sos_Bool sos_Type::local_equal(sos_Type x,sos_Type y,sos_Eq_kind eq_kind){return (_sos_Type::local_equal(x,y,eq_kind));}
void sos_Type::assign(sos_Object source){(_ref->assign(_tpid,source));}
sos_Bool sos_Type::equal(sos_Object o,sos_Eq_kind eq_kind){return (_ref->equal(_tpid,o,eq_kind));}
sos_Type sos_Type::base(){return (_ref->base(_tpid));}
sos_Int sos_Type::get_object_size(){return (_ref->get_object_size(_tpid));}
void sos_Type::set_object_size(sos_Int _p1){(_ref->set_object_size(_tpid,_p1));}
sos_Type sos_Type::type(){return (_ref->type(_tpid));}
sos_Bool sos_Type::is_some(sos_Type _p1){return (_ref->is_some(_tpid,_p1));}
sos_Bool sos_Type::is_value(){return (_ref->is_value(_tpid));}
sos_Int sos_Type::size(){return (_ref->size(_tpid));}
sos_Bool sos_Type::identical(sos_Object _p1){return (_ref->identical(_tpid,_p1));}
sos_Bool sos_Type::like(sos_Object _p1){return (_ref->like(_tpid,_p1));}
sos_Comp_result sos_Type::compare_ids(sos_Object _p1){return (_ref->compare_ids(_tpid,_p1));}
sos_Int sos_Type::local_hash_value(sos_Type x){return (_sos_Type::local_hash_value(x));}
static struct _sos_init_dummy {
   _sos_init_dummy() {_knl_init_sos();}   ~_sos_init_dummy(){}
   } _sos_dummy;
static int _sos_initialized=0;
void _knl_init_sos(){
   if (_sos_initialized) return;
   _sos_initialized=1;
   cci_Schema_impl::enter_make_obj(_sos_Object_type,_sos_Int_type,(_sos_Object*) new _sos_Scalar_object);
   cci_Schema_impl::enter_make_obj(_sos_Scalar_object_type,_sos_Int_type,(_sos_Scalar_object*) new _sos_Scalar_object);
   cci_Schema_impl::enter_string_io (_sos_Int_type,(cci_IO_fun)make_string_from_sos_Int_object,(cci_IO_fun)make_sos_Int_object_from_string);
   cci_Schema_impl::enter_make_obj(_sos_Object_type,_sos_Char_type,(_sos_Object*) new _sos_Scalar_object);
   cci_Schema_impl::enter_make_obj(_sos_Scalar_object_type,_sos_Char_type,(_sos_Scalar_object*) new _sos_Scalar_object);
   cci_Schema_impl::enter_string_io (_sos_Char_type,(cci_IO_fun)make_string_from_sos_Char_object,(cci_IO_fun)make_sos_Char_object_from_string);
   cci_Schema_impl::enter_make_obj(_sos_Object_type,_sos_Cstring_type,(_sos_Object*) new _sos_Scalar_object);
   cci_Schema_impl::enter_make_obj(_sos_Scalar_object_type,_sos_Cstring_type,(_sos_Scalar_object*) new _sos_Scalar_object);
   cci_Schema_impl::enter_string_io (_sos_Cstring_type,(cci_IO_fun)make_string_from_sos_Cstring_object,(cci_IO_fun)make_sos_Cstring_object_from_string);
   cci_Schema_impl::enter_make_obj(_sos_Object_type,_sos_Pointer_type,(_sos_Object*) new _sos_Scalar_object);
   cci_Schema_impl::enter_make_obj(_sos_Scalar_object_type,_sos_Pointer_type,(_sos_Scalar_object*) new _sos_Scalar_object);
   cci_Schema_impl::enter_string_io (_sos_Pointer_type,(cci_IO_fun)make_string_from_sos_Pointer_object,(cci_IO_fun)make_sos_Pointer_object_from_string);
   cci_Schema_impl::enter_make_obj(_sos_Object_type,_sos_Container_type,(_sos_Object*) new _sos_Scalar_object);
   cci_Schema_impl::enter_make_obj(_sos_Scalar_object_type,_sos_Container_type,(_sos_Scalar_object*) new _sos_Scalar_object);
   cci_Schema_impl::enter_string_io (_sos_Container_type,(cci_IO_fun)make_string_from_sos_Container_object,(cci_IO_fun)make_sos_Container_object_from_string);
   cci_Schema_impl::enter_make_obj(_sos_Object_type,_sos_Id_type,(_sos_Object*) new _sos_Scalar_object);
   cci_Schema_impl::enter_make_obj(_sos_Scalar_object_type,_sos_Id_type,(_sos_Scalar_object*) new _sos_Scalar_object);
   cci_Schema_impl::enter_string_io (_sos_Id_type,(cci_IO_fun)make_string_from_sos_Id_object,(cci_IO_fun)make_sos_Id_object_from_string);
   cci_Schema_impl::enter_make_obj(_sos_Object_type,_sos_Offset_type,(_sos_Object*) new _sos_Scalar_object);
   cci_Schema_impl::enter_make_obj(_sos_Scalar_object_type,_sos_Offset_type,(_sos_Scalar_object*) new _sos_Scalar_object);
   cci_Schema_impl::enter_string_io (_sos_Offset_type,(cci_IO_fun)make_string_from_sos_Offset_object,(cci_IO_fun)make_sos_Offset_object_from_string);
   cci_Schema_impl::enter_make_obj(_sos_Object_type,_sos_Bool_type,(_sos_Object*) new _sos_Scalar_object);
   cci_Schema_impl::enter_make_obj(_sos_Scalar_object_type,_sos_Bool_type,(_sos_Scalar_object*) new _sos_Scalar_object);
   cci_Schema_impl::enter_make_obj(_sos_Object_type,_sos_Eq_kind_type,(_sos_Object*) new _sos_Scalar_object);
   cci_Schema_impl::enter_make_obj(_sos_Scalar_object_type,_sos_Eq_kind_type,(_sos_Scalar_object*) new _sos_Scalar_object);
   cci_Schema_impl::enter_make_obj(_sos_Object_type,_sos_Comp_result_type,(_sos_Object*) new _sos_Scalar_object);
   cci_Schema_impl::enter_make_obj(_sos_Scalar_object_type,_sos_Comp_result_type,(_sos_Scalar_object*) new _sos_Scalar_object);
   __sos_Object_obj=new _sos_Object;
   _init_meth_15319856_3764();
   _init_comp_15319856_3764();
   _init_stat_15319856_3764();
   _init_new_15319856_3764();
   __sos_Ordered_object_obj=new _sos_Ordered_object;
   _init_meth_15319856_13556();
   _init_comp_15319856_13556();
   _init_stat_15319856_13556();
   _init_new_15319856_13556();
   __sos_Scalar_object_obj=new _sos_Scalar_object;
   _init_meth_15319856_21084();
   _init_comp_15319856_21084();
   _init_stat_15319856_21084();
   _init_new_15319856_21084();
   __sos_String_obj=new _sos_String;
   _init_meth_15319856_28364();
   _init_comp_15319856_28364();
   _init_stat_15319856_28364();
   _init_new_15319856_28364();
   __sos_Named_obj=new _sos_Named;
   _init_meth_15319856_39164();
   _init_comp_15319856_39164();
   _init_stat_15319856_39164();
   _init_new_15319856_39164();
   __sos_Type_obj=new _sos_Type;
   _init_meth_15319856_45644();
   _init_comp_15319856_45644();
   _init_stat_15319856_45644();
   _init_new_15319856_45644();
}
